## fzifdso 0.4.0

=== debian/changelog ===
fzifdso (0.4.0-1+bpo12~1) bookworm; urgency=medium

  * Rebuild for bookworm.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 29 Mar 2024 20:40:38 +0100

fzifdso (0.4.0-1) unstable; urgency=medium

  * Initial packaging, version 0.4.0 (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 29 Mar 2024 13:51:23 +0100
