=== debian/control ===
Source: fzifdso
Section: admin
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/fzifdso.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/fzifdso.deb
Homepage: https://sr.ht/~nabijaczleweli/fzifdso
Build-Depends: debhelper,
               debhelper-compat (= 13),
               mandoc <!nodoc>,
               pkg-config,
               libzfslinux-dev,
               libfido2-dev,
               libssl-dev,
               systemd-dev | systemd,
               gettext <!pkg.fzifdso.noloc>,

Package: fzifdso
Recommends: tzpfms-common (>= 0.4.0-1)
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
#Tag: admin::filesystem, implemented-in::c++, interface::commandline, role::program, scope::utility, use::configuring
Description: FIDO2 encryption keys for ZFS datasets – binaries
 fzifdso provides tooling to manage keys for encrypted ZFS datasets
 by binding them to FIDO2/WebAuthn devices (like the YubiKey, Somu, &c.),
 thus requiring the right device and a presence check to unlock.
 .
 This package contains zfs-fido2-{{change,list,clear}-key,add-backup}
 for managing keys backed by FIDO2 devices.

Package: fzifdso-dracut
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         tzpfms-common (>= 0.4.0-1),
         fzifdso,
         zfs-dracut,
#Tag: admin::filesystem, admin::boot, implemented-in::shell, role::plugin
Description: FIDO2 encryption keys for ZFS datasets – Dracut hooks
 fzifdso provides tooling to manage keys for encrypted ZFS datasets
 by binding them to FIDO2/WebAuthn devices (like the YubiKey, Somu, &c.),
 thus requiring the right device and a presence check to unlock.
 .
 This package contains Dracut hooks for booting with an encrypted ZFS rootfs
 backed by fzifdso.

Package: fzifdso-initramfs
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
         tzpfms-common (>= 0.4.0-1),
         fzifdso,
         zfs-initramfs,
#Tag: admin::filesystem, admin::boot, implemented-in::shell, role::plugin
Description: FIDO2 encryption keys for ZFS datasets – initramfs-tools hooks
 fzifdso provides tooling to manage keys for encrypted ZFS datasets
 by binding them to FIDO2/WebAuthn devices (like the YubiKey, Somu, &c.),
 thus requiring the right device and a presence check to unlock.
 .
 This package contains initramfs-tools hooks for booting
 with an encrypted ZFS rootfs backed by fzifdso.
