=== debian/watch ===
version=4
opts="filenamemangle=s/.*\/v?(\d\S+)\.tar\.gz/fzifdso-$1\.tar\.gz/, pgpsigurlmangle=s/$/.asc/" \
  https://git.sr.ht/~nabijaczleweli/fzifdso/refs .*/v?(\d\S+)\.tar\.gz
