## fzifdso 0.4.1

=== debian/changelog ===
fzifdso (0.4.1-1) unstable; urgency=medium

  * New upstream version 0.4.1 (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 09 Mar 2025 17:17:04 +0100
