=== debian/rules ===
#!/usr/bin/make -f


export DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export FZIFDSO_VERSION := "$(shell IFS="$$IFS()" read -r _ v _ < debian/changelog && echo "$$v")"
export TZ := UTC0
export NOLOCREGEN := @\#

targets := $(filter-out htmlpages shellcheck,$(shell sed -n '/^all :/s///p' Makefile))
ifneq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
targets := $(filter-out %pages,$(targets))
endif


override_dh_auto_build:
	dh_auto_build -- $(targets) TZPFMS_PASSPHRASE_HELPER='exec systemd-ask-password --id="tzpfms:$$$$2" "$$$$1:"' TZPFMS_PASSPHRASE_HELPER_MAN='Ic exec Nm systemd-ask-password Fl -id Ns Li = Ns Qo Li tzpfms:\& Ns Ar $$$$2 Qc Qo Ar $$$$1 Ns Li ":\&" Qc'

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs -A README.md
	cp debian/NEWS.upstream debian/fzifdso/usr/share/doc/fzifdso/NEWS

%:
	dh $@
